#ifndef VESSELDETECTOR_H
#define VESSELDETECTOR_H

#include "types.h"

template<typename T> class Data3D;

class Vesselness;
class Vesselness_Sig;
class Vesselness_Nor;
class Vesselness_All;

namespace VesselDetector {
bool hessien(
    const Data3D<float>& src, Data3D<Vesselness>& dst,
    int ksize, float sigma,
    float alpha, float beta, float gamma );

int compute_vesselness(
    const Data3D<float>& src,
    Data3D<Vesselness_Sig>& dst,
    float sigma_from, float sigma_to, float sigma_step,
    float alpha = 1.0e-1f,
    float beta  = 5.0e0f,
    float gamma = 3.5e5f );
};

namespace VD = VesselDetector;
namespace VF = VesselDetector;

#endif
